Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPNMoveEvaluator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPNMoveEvaluator.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPNMoveEvaluator.cs	(revision 7970)
@@ -20,5 +20,4 @@
 #endregion
 
-using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -35,6 +34,7 @@
   public class GQAPNMoveEvaluator : SingleSuccessorOperator, IGQAPNMoveEvaluator, IAssignmentAwareGQAPOperator,
   IQualityAwareGQAPOperator, ITransportationCostsAwareGQAPOperator,
-  IOverbookedCapacityPenaltyAwareGQAPOperator, IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator,
-  IInstallationCostsAwareGQAPOperator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator {
+  IExpectedRandomQualityAwareGQAPOperator, IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator,
+  IInstallationCostsAwareGQAPOperator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator,
+  IEvaluatorAwareGQAPOperator {
 
     #region Parameter Descriptions
@@ -94,6 +94,6 @@
       get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
     }
     public ILookupParameter<DoubleMatrix> WeightsParameter {
@@ -111,4 +111,7 @@
     public ILookupParameter<DoubleArray> CapacitiesParameter {
       get { return (ILookupParameter<DoubleArray>)Parameters["Capacities"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
     #endregion
@@ -130,5 +133,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("MoveInstallationQuality", MoveInstallationQualityDescription));
       Parameters.Add(new LookupParameter<DoubleValue>("MoveOverbookedCapacity", MoveOverbookedCapacityDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", GeneralizedQuadraticAssignmentProblem.OverbookedCapacityPenaltyDescription));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
       Parameters.Add(new LookupParameter<DoubleMatrix>("Weights", GeneralizedQuadraticAssignmentProblem.WeightsDescription));
@@ -137,4 +140,5 @@
       Parameters.Add(new LookupParameter<DoubleArray>("Demands", GeneralizedQuadraticAssignmentProblem.DemandsDescription));
       Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
@@ -144,14 +148,14 @@
 
     public static double Evaluate(NMove move, IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
-      DoubleArray demands, DoubleArray capacities, DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty) {
+      DoubleArray demands, DoubleArray capacities, double transportationCosts, double expectedRandomQuality, IGQAPEvaluator evaluator) {
       double moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity;
-      Evaluate(move, assignment, weights, distances, installationCosts, demands, capacities,
+      Evaluate(move, assignment, weights, distances, installationCosts, demands, capacities, evaluator,
         out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
-      return GQAPEvaluator.GetCombinedQuality(moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity,
-        transportationCosts.Value, overbookedCapacityPenalty.Value);
+      return evaluator.GetFitness(moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity,
+        transportationCosts, expectedRandomQuality);
     }
 
     public static void Evaluate(NMove move, IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
-      DoubleArray demands, DoubleArray capacities, out double moveFlowDistanceQuality, out double moveInstallationQuality, out double moveOverbookedCapacity) {
+      DoubleArray demands, DoubleArray capacities, IGQAPEvaluator evaluator, out double moveFlowDistanceQuality, out double moveInstallationQuality, out double moveOverbookedCapacity) {
       moveFlowDistanceQuality = moveInstallationQuality = moveOverbookedCapacity = 0.0;
       int moves = move.N;
@@ -184,13 +188,13 @@
       }
 
-      moveOverbookedCapacity = slack.Select((v, i) => new { V = v, Index = i }).Where(x => x.V < 0.0).Select(x => -x.V / capacities[x.Index]).Sum()
-                               - oldSlack.Select((v, i) => new { V = v, Index = i }).Where(x => x.V < 0.0).Select(x => -x.V / capacities[x.Index]).Sum();
+      moveOverbookedCapacity = evaluator.EvaluateOverbooking(slack, capacities) - evaluator.EvaluateOverbooking(oldSlack, capacities);
     }
 
     public override IOperation Apply() {
+      var evaluator = EvaluatorParameter.ActualValue;
       double moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity;
       double quality = QualityParameter.ActualValue.Value;
       double transportationCosts = TransportationCostsParameter.ActualValue.Value;
-      double overbookedCapacityPenalty = OverbookedCapacityPenaltyParameter.ActualValue.Value;
+      double expectedRandomQuality = ExpectedRandomQualityParameter.ActualValue.Value;
 
       double flowDistanceQuality = FlowDistanceQualityParameter.ActualValue.Value;
@@ -203,4 +207,5 @@
                InstallationCostsParameter.ActualValue,
                DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
+               evaluator,
                out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
 
@@ -209,10 +214,9 @@
       MoveOverbookedCapacityParameter.ActualValue = new DoubleValue(overbookedCapacity + moveOverbookedCapacity);
 
-      MoveQualityParameter.ActualValue = new DoubleValue(GQAPEvaluator.GetCombinedQuality(
+      MoveQualityParameter.ActualValue = new DoubleValue(evaluator.GetFitness(
         flowDistanceQuality + moveFlowDistanceQuality,
         installationQuality + moveInstallationQuality,
         overbookedCapacity + moveOverbookedCapacity,
-        transportationCosts,
-        overbookedCapacityPenalty));
+        transportationCosts, expectedRandomQuality));
       return base.Apply();
     }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPPenaltyLevelEvaluator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPPenaltyLevelEvaluator.cs	(revision 7970)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPPenaltyLevelEvaluator.cs	(revision 7970)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  [Item("GQAPPenaltyLevelEvaluator", "Evaluates solutions to the generalized quadratic assignment problem using a penalty level strategy. Infeasible solutions have a certain base quality to which the amount of constraint violation is added.")]
+  [StorableClass]
+  public class GQAPPenaltyLevelEvaluator : GQAPEvaluator {
+    public static readonly string PenaltyDescription = "The percentage of the expected random quality that should be used as a base level for infeasible solutions.";
+
+    protected IValueParameter<PercentValue> PenaltyParameter {
+      get { return (IValueParameter<PercentValue>)Parameters["Penalty"]; }
+    }
+
+    public PercentValue Penalty {
+      get { return PenaltyParameter.Value; }
+      set { PenaltyParameter.Value = value; }
+    }
+
+    [StorableConstructor]
+    protected GQAPPenaltyLevelEvaluator(bool deserializing) : base(deserializing) { }
+    protected GQAPPenaltyLevelEvaluator(GQAPPenaltyLevelEvaluator original, Cloner cloner) : base(original, cloner) { }
+    public GQAPPenaltyLevelEvaluator()
+      : base() {
+      Parameters.Add(new ValueParameter<PercentValue>("Penalty", PenaltyDescription, new PercentValue(1), true));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GQAPPenaltyLevelEvaluator(this, cloner);
+    }
+
+    public override double GetFitness(double flowDistanceQuality,
+      double installationQuality, double overbookedCapacity,
+      double transportationCosts, double expectedRandomQuality) {
+      if (overbookedCapacity > 0) {
+        return expectedRandomQuality * Penalty.Value + overbookedCapacity;
+      } else {
+        return installationQuality
+          + transportationCosts * flowDistanceQuality;
+      }
+    }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignment.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignment.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignment.cs	(revision 7970)
@@ -176,11 +176,22 @@
 
     [Storable]
-    private DoubleValue overbookedCapacityPenalty;
-    public DoubleValue OverbookedCapacityPenalty {
-      get { return overbookedCapacityPenalty; }
-      set {
-        bool changed = (overbookedCapacityPenalty != value);
-        overbookedCapacityPenalty = value;
-        if (changed) OnPropertyChanged("OverbookedCapacityPenalty");
+    private DoubleValue expectedRandomQuality;
+    public DoubleValue ExpectedRandomQuality {
+      get { return expectedRandomQuality; }
+      set {
+        bool changed = (expectedRandomQuality != value);
+        expectedRandomQuality = value;
+        if (changed) OnPropertyChanged("ExpectedRandomQuality");
+      }
+    }
+
+    [Storable]
+    private IGQAPEvaluator evaluator;
+    public IGQAPEvaluator Evaluator {
+      get { return evaluator; }
+      set {
+        bool changed = (evaluator != value);
+        evaluator = value;
+        if (changed) OnPropertyChanged("Evaluator");
       }
     }
@@ -203,7 +214,8 @@
       capacities = cloner.Clone(original.capacities);
       transportationCosts = cloner.Clone(original.transportationCosts);
-      overbookedCapacityPenalty = cloner.Clone(original.overbookedCapacityPenalty);
-    }
-    public GQAPAssignment(IntegerVector assignment, DoubleValue quality, DoubleValue flowDistanceQuality, DoubleValue installationQuality, DoubleValue overbookedCapacity, StringArray equipmentNames, StringArray locationNames, DoubleMatrix distances, DoubleMatrix weights, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities, DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty)
+      expectedRandomQuality = cloner.Clone(original.expectedRandomQuality);
+      evaluator = cloner.Clone(original.evaluator);
+    }
+    public GQAPAssignment(IntegerVector assignment, DoubleValue quality, DoubleValue flowDistanceQuality, DoubleValue installationQuality, DoubleValue overbookedCapacity, StringArray equipmentNames, StringArray locationNames, DoubleMatrix distances, DoubleMatrix weights, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities, DoubleValue transportationCosts, DoubleValue expectedRandomQuality, IGQAPEvaluator evaluator)
       : base() {
       this.assignment = assignment;
@@ -220,5 +232,6 @@
       this.capacities = capacities;
       this.transportationCosts = transportationCosts;
-      this.overbookedCapacityPenalty = overbookedCapacityPenalty;
+      this.expectedRandomQuality = expectedRandomQuality;
+      this.evaluator = evaluator;
     }
 
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignmentArchive.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignmentArchive.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignmentArchive.cs	(revision 7970)
@@ -131,11 +131,22 @@
 
     [Storable]
-    private DoubleValue overbookedCapacityPenalty;
-    public DoubleValue OverbookedCapacityPenalty {
-      get { return overbookedCapacityPenalty; }
+    private DoubleValue expectedRandomQuality;
+    public DoubleValue ExpectedRandomQuality {
+      get { return expectedRandomQuality; }
       set {
-        bool changed = (overbookedCapacityPenalty != value);
-        overbookedCapacityPenalty = value;
-        if (changed) OnPropertyChanged("OverbookedCapacityPenalty");
+        bool changed = (expectedRandomQuality != value);
+        expectedRandomQuality = value;
+        if (changed) OnPropertyChanged("ExpectedRandomQuality");
+      }
+    }
+
+    [Storable]
+    private IGQAPEvaluator evaluator;
+    public IGQAPEvaluator Evaluator {
+      get { return evaluator; }
+      set {
+        bool changed = (evaluator != value);
+        evaluator = value;
+        if (changed) OnPropertyChanged("Evaluator");
       }
     }
@@ -154,5 +165,6 @@
       capacities = cloner.Clone(original.capacities);
       transportationCosts = cloner.Clone(original.transportationCosts);
-      overbookedCapacityPenalty = cloner.Clone(original.overbookedCapacityPenalty);
+      expectedRandomQuality = cloner.Clone(original.expectedRandomQuality);
+      evaluator = cloner.Clone(original.evaluator);
     }
     public GQAPAssignmentArchive()
@@ -160,5 +172,5 @@
       this.solutions = new ItemList<GQAPSolution>();
     }
-    public GQAPAssignmentArchive(StringArray equipmentNames, StringArray locationNames, DoubleMatrix distances, DoubleMatrix weights, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities, DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty)
+    public GQAPAssignmentArchive(StringArray equipmentNames, StringArray locationNames, DoubleMatrix distances, DoubleMatrix weights, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities, DoubleValue transportationCosts, DoubleValue expectedRandomQuality, IGQAPEvaluator evaluator)
       : this() {
       this.distances = distances;
@@ -168,5 +180,6 @@
       this.capacities = capacities;
       this.transportationCosts = transportationCosts;
-      this.overbookedCapacityPenalty = overbookedCapacityPenalty;
+      this.expectedRandomQuality = expectedRandomQuality;
+      this.evaluator = evaluator;
     }
 
